/*  Copyright (C) 2023 Tibor 'Igor2' Palinkas - license: Creative Commons CC0 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#include <libgpcogl/libgpcogl.h>
#include <libgpcogl/gli.h>

int main(int argc, char **argv)
{
	gpcogl_t ctx;         /* lib context all arrays and shader programs are in */

	/* Initialize the opengl interface library (e.g. glut or noxgl) */
	gpcogl_gli_init(&argc, argv);

	/* Create a context (hidden X window with glut) for off-screen rendering */
	if (gpcogl_gli_make_context(&ctx, NULL) != 0)
		return 1;

	printf("gpcogl version:  %d.%d.%d\n", gpcogl_ver_major, gpcogl_ver_minor, gpcogl_ver_patch);
	printf("gl vendor:       %s\n", ctx.gl_vendor);
	printf("renderer vendor: %s\n", ctx.renderer_vendor);
	printf("version:         %d.%d\n", ctx.glver_major, ctx.glver_minor);

	/* free context and lib globals */
	gpcogl_gli_destroy_context(&ctx);
	gpcogl_gli_uninit();

	return 0;
}
