/*  Copyright (C) 2023 Tibor 'Igor2' Palinkas - license: Creative Commons CC0 */

#include <stdio.h>
#include "input.c"

float state1[SX*SY], state2[SX*SY];

void pre_iterate(float *state, const float *input)
{
	long n, len = SX*SY;
	for(n = 0; n < len; n++,state++,input++)
		if (*input != 0)
			*state = *input;
}

void iterate(float *new_st, const float *old_st)
{
	long x, y, idx;
	for(y = 1; y < SY-1; y++) {
		idx = y * SX + 1;
		for(x = 1; x < SX-1; x++,idx++) {
			new_st[idx] = (old_st[idx-1] + old_st[idx+1] + old_st[idx-SX] + old_st[idx+SX])/4.0;
		}
	}
}


int main()
{
	int n;

	printf("initial:\n");
	pre_iterate(state1, input_temps);
	print_mx(state1);

	for(n = 0; n < 100; n++) {
		pre_iterate(state1, input_temps);
		iterate(state2, state1);
		pre_iterate(state2, input_temps);
		iterate(state1, state2);
	}

	printf("end:\n");
	pre_iterate(state1, input_temps);
	print_mx(state1);
}
